//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue;

import figue.box.GlyphInterface;
import figue.path.PathInterface;
import figue.path.SelectionPathInterface;
import figue.resource.ColorInterface;
import figue.resource.WrongResourceException;
import figue.resource.BasicColor;
import figue.resource.FontInterface;
import figue.resource.FontFamily;
import figue.resource.FontStyle;
import figue.resource.StyleInterface;
import figue.resource.PortableFontInterface;
import figue.selection.SelectionInterface;
import figue.selection.WrongSelectionException;
import figue.geometry.Rectangle;
import figue.error.ErrorHandlerInterface;
import figue.io.ExternalizableAsXMLInterface;
import figue.internal.ContextInterface;

import java.util.Enumeration;

/**
 * [PENDING: update the comments] FacadeInterface.
 */

public interface FacadeInterface extends ErrorHandlerInterface, ExternalizableAsXMLInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/FacadeInterface.java,v $ $revision$ $Date: 1998/11/02 15:54:30 $ Copyright 1998 INRIA.";
 
    /**
     * [PENDING: update the comments] awake
     * @level advanced
     */
    public void awake(); /// NEW TEMPO TEMPO
    /**
     * [PENDING: update the comments] awakeWithoutInactive
     * @level advanced
     */
    public void awakeWithoutInactive(); //// +++ NEW PUBLIC BEURK
    public GlyphInterface getRootGlyph(); /// TEMPO
    /**
     * [PENDING: update the comments] initDone
     * @level advanced
     */
    public void initDone(); /// TEMPO TEMPO
    /**
     * [PENDING: update the comments] fatalError
     * @level advanced
     */
    public void fatalError(); /// TEMPO TEMPO
    /**
     * [PENDING: update the comments] waitUntilFormattingResumed
     * @level advanced
     */
    public void waitUntilFormattingResumed(); /// TEMPO TEMPO  
    /**
     * [PENDING: update the comments] suspendFormatting
     * @level advanced
     */
    public void suspendFormatting(); /// +++ 
    public void disposeWhenInactive();
    public boolean isDisposed();
    public int getFormattingWidth();
    public void setFormattingWidth(int aWidth);
    public void updateAndRedisplay(PathInterface aPath);
    public void buildInit(PathInterface aPath);
    public void build(PathInterface aPath);
    public void buildComplete();
    public void updateSelectionAndRedisplay(PathInterface aPath);
    public void updateSelection(PathInterface aPath);
    public void insureVisible(PathInterface aPath);
    public SelectionPathInterface getSelectionPath();
    public void refresh(Rectangle aRectangle);
    public void refresh();
    public boolean isSelectionDefined(String aMnemonic);
    public SelectionInterface getSelection(String aName) throws WrongSelectionException;
    public SelectionInterface doGetSelection(String aName,
					     Priority aPriority,
					     String aColorName,
					     String aBackgroundName)
	throws WrongSelectionException;
    public SelectionInterface doGetSelection(String aName,
					     Priority aPriority,
					     ColorInterface aColor,
					     ColorInterface aBackground)
	throws WrongSelectionException;
    public Enumeration selections();
    public boolean isColorDefined(String aMnemonic);
    public ColorInterface getColor(String aMnemonic) 
	throws WrongResourceException;
    public ColorInterface doGetColor(String aMnemonic,BasicColor aColor)
	throws WrongResourceException;
    public ColorInterface doGetColor(String aMnemonic,
				     int red, int green, int blue)
	throws WrongResourceException;
    public Enumeration colors();
    public boolean isFontDefined(String aMnemonic);
    public FontInterface getFont(String aMnemonic)
	throws WrongResourceException;
    public FontInterface doGetFont(String aMnemonic,
				   FontFamily aFamily,
				   FontStyle aStyle,
				   int aPointSize,
				   boolean anUnderlinedFlag) 
	throws WrongResourceException;
    public Enumeration fonts();
    public boolean isStyleDefined(String aMnemonic);
    public StyleInterface getStyle(String aMnemonic)
	throws WrongResourceException;
    public StyleInterface doGetStyle(String aMnemonic,
				     FontInterface aFont,
				     ColorInterface aColor,
				     ColorInterface aBackground) 
	throws WrongResourceException;
    public Enumeration styles();
    public ColorInterface doGetDefaultColor();
    public ColorInterface doGetDefaultBackground();
    public FontInterface doGetDefaultFont();
    public StyleInterface doGetDefaultStyle();
    public PortableFontInterface doGetPortableFont(String aMnemonic,
						   String aName,
						   int aDpi,
						   double aScale) throws WrongResourceException;
    public PortableFontInterface getPortableFont(String aMnemonic) throws WrongResourceException;
    public boolean isPortableFontDefined(String aMnemonic);
    public Enumeration portableFonts();
    public void executeWhenInactive(CommandInterface aCommand);
    /**
     * [PENDING: update the comments] getContext
     * @level advanced
     */
    public ContextInterface getContext(); /// TEMPO TEMPO

}

