//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue;

import figue.resource.FontMetricInterface;
import figue.internal.ContextInterface;

/**
 * [PENDING: update the comments] Measure.
 */

public final class Measure implements MeasureInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/Measure.java,v $ $revision$ $Date: 1998/11/02 15:54:33 $ Copyright 1998 INRIA.";

    public Measure(int aValue, UnitInterface anUnit) {
	_value = aValue;
	try {
	    _unit = (UnitInterface)(anUnit.clone());
	}
	catch ( CloneNotSupportedException anException ) {
	}
	_lastValue = -1;
    }

    public Object clone() throws CloneNotSupportedException {
 	final Measure theResult = (Measure) super.clone();
	theResult._value = _value;
	theResult._unit = (UnitInterface)_unit.clone();
 	return theResult;
    }
    
    public final void setFontMetric(ContextInterface aContext,
				    FontMetricInterface aFontMetric) {
	if ( _unit.setCurrentFontMetric(aContext,aFontMetric) ) {
	    _lastValue = -1;
	}
    }

    public final UnitInterface getUnit() {
	return _unit;
    }
  
    public final void setUnit(UnitInterface anUnit) {
	if ( ! anUnit.equals(_unit) ) {
	    anUnit.dispose();
	    _unit = anUnit;
	    _lastValue = -1;
	}
    }
  
    public final int getValue() {
	return _value;
    }

    public final void setValue(int aValue) {
	if ( aValue != _value ) {
	    _value = aValue;
	    _lastValue = -1;
	}
    }
  
    public final int getValueInPixel() {
	if ( _lastValue == -1 ) {
	    _lastValue = _unit.convertValueInPixel(_value);
	}
	return _lastValue;
    }

    public final boolean equals(Object anObject) {
	if ( this == anObject ) {
	    return true;
	}
	if ( getClass() != anObject.getClass() ) {
	    return false;
	}
	MeasureInterface theOtherObject  = (MeasureInterface)anObject;
	return ( ( getValue() == theOtherObject.getValue() ) 
		 && ( getUnit().equals(theOtherObject.getUnit() ) ) );
    }

    protected final void finalize() {
	dispose();
    }
  
    public final void dispose() {
	_unit.dispose();
    }

    public final String toString() {
	StringBuffer theResult = new StringBuffer("Measure<");
	theResult.append(_value).append('(').append(_unit).append(')');
	if ( _lastValue != -1 ) {
	    theResult.append('=').append(_lastValue);
	}
	theResult.append(">");
	return theResult.toString();
    }

    private int _value;
    private UnitInterface _unit;
    private int _lastValue;
  
}
