//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.box;

import figue.resource.StyleInitializer;
import figue.resource.StyleInterface;
import figue.resource.StyleDefered;
import figue.resource.ColorInterface;
import figue.resource.FontInterface;
import figue.resource.StyleOwnerInterface;

import java.io.Writer;
import java.io.IOException;
import figue.io.Utility;

/**
 * [PENDING: update the comments] ChangeGraphicalContextNamed.
 */

public final class ChangeGraphicalContextNamed extends ChangeGraphicalContextAbstract implements StyleOwnerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/box/ChangeGraphicalContextNamed.java,v $ $revision$ $Date: 1998/11/02 15:54:36 $ Copyright 1998 INRIA.";
  
    public ChangeGraphicalContextNamed(String aName) {
	super();
	_style = new StyleDefered(aName,new StyleInitializer(this));
    }
  
    public ChangeGraphicalContextNamed(StyleInterface aStyle) {
	super();
	_style = aStyle;
    }

    public Object clone() throws CloneNotSupportedException {
	final ChangeGraphicalContextNamed theResult = (ChangeGraphicalContextNamed) super.clone();
	theResult._style = new StyleDefered(_style.getName(),new StyleInitializer(theResult));
	return theResult;
    }
  
    public final FontInterface getFont() {
	return _style.getFont();
    }
  
    public final ColorInterface getColor() {
	return _style.getColor();
    }

    public final ColorInterface getBackground() {
	return _style.getBackground();
    }

    public final void setStyle(StyleInterface aStyle) {
	_style = aStyle;
    }

    public final String toString() {
	StringBuffer theResult = new StringBuffer("ChangeGraphicalContext<");
	theResult.append("style: ").append(_style.toString());
	theResult.append(super.toString()).append(">");
	return theResult.toString();
    }

    protected final void writeIntrinsicState(Writer anOutput) throws IOException {
	super.writeIntrinsicState(anOutput);
	anOutput.write(" Style=\"");
	Utility.writeStringAsXmlValue(anOutput,_style.getName());
	anOutput.write("\"");
    }

    private StyleInterface _style;

}
