//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.box;

/**
 * [PENDING: update the comments] DecoratedGlyph.
 * @level advanced
 */

public abstract class DecoratedGlyph extends DecoratedGlyphAbstract {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/box/DecoratedGlyph.java,v $ $revision$ $Date: 1998/11/02 15:54:37 $ Copyright 1998 INRIA.";
  
    protected DecoratedGlyph(GlyphInterface aGlyph) {
	super();
	_component = aGlyph;
	getComponent().setParent(this);
    }

    public DecoratedGlyph() {
	this(NullGlyph.INSTANCE);
    }

    public Object clone() throws CloneNotSupportedException {
 	final DecoratedGlyph theResult = (DecoratedGlyph) super.clone();
	theResult._component = (GlyphInterface)_component.clone();
	theResult.getComponent().setParent(theResult);
 	return theResult;
    }


    protected final GlyphInterface getComponent() {
	return  _component;
    }

    protected final void setComponent(GlyphInterface aGlyph) {
	_component = aGlyph;
    }

    private GlyphInterface _component;
  
}

