//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.box;

import figue.path.SelectionPathInterface;
import figue.resource.FontMetricInterface;
import figue.geometry.Dimension;
import figue.geometry.Transformer;
import figue.format.DistanceInterface;
import figue.internal.ContextInterface;

/**
 * [PENDING: update the comments] FlyWeightAtomInterface.
 * @level advanced
 */

public interface FlyWeightAtomInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/box/FlyWeightAtomInterface.java,v $ $revision$ $Date: 1998/11/02 15:54:38 $ Copyright 1998 INRIA.";
  
    public void dispose();
    public FlyWeightAtomInterface format2D(ContextInterface aContext,
					   FontMetricInterface aFontMetric,
					   DistanceInterface aDistance);
    public int computeWidth(FontMetricInterface aFontMetric);
    public void draw2DClean(GlyphInterface anOwner,
			    ContextInterface aContext,
			    Transformer aTransformer,
			    SelectionPathInterface aSelectionPath);
    public void draw2DClean(GlyphInterface anOwner,
			    ContextInterface aContext,
			    Transformer aTransformer);
    public Dimension getSizeValue();
  
    public void setFontMetric(FontMetricInterface aFontMetric);
    public FontMetricInterface getFontMetric();
    public Dimension getSize();
    public void setSize(Dimension aSize);
  
    public String getText();

}

