//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.box;

import figue.Measure;
import figue.UnitInterface;
import figue.MeasureInterface;
import figue.internal.VectorGlyph;

/**
 * [PENDING: update the comments] Horizontal.
 */

public final class Horizontal extends HorizontalAbstract {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/box/Horizontal.java,v $ $revision$ $Date: 1998/11/02 15:54:40 $ Copyright 1998 INRIA.";

    public Horizontal(MeasureInterface anInterword) {
	super(anInterword);
	_children = new VectorGlyph(5,5);
    }

    public Horizontal(int anInterword) {
	this(new Measure(anInterword,UnitInterface.BLANK_TENTH));
    }

    public Horizontal() {
	this(10);
    }

    public final Object clone() throws CloneNotSupportedException {
	final Horizontal theResult = (Horizontal) super.clone();
	theResult._children = new VectorGlyph(numberOfChildren(),5);
	final int theSize = numberOfChildren();
	for ( int theRank = 0; theRank < theSize; theRank++ ) {
	    theResult.addChild((GlyphInterface)getChild(theRank).clone());
	}
	return theResult;
    }
  
    public final GlyphInterface getChild(int aRank) {
	return _children.elementAt(aRank);
    }
  
    public final void insertChild(int aRank, GlyphInterface aGlyph) {
	super.insertChild(aRank,aGlyph);
	_children.insertElementAt(aGlyph,aRank);
    }
  
    public final void replaceChild(int aRank, GlyphInterface aGlyph) {
	super.replaceChild(aRank,aGlyph);
	_children.setElementAt(aGlyph,aRank);
    }
  
    public final void removeChild(int aRank) {
	super.removeChild(aRank);
	_children.removeElementAt(aRank);
    }
  
    public final int numberOfChildren() { 
	return _children.size(); 
    }
  
    private VectorGlyph _children; 
    
}
