//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.doclet;

import com.sun.javadoc.*;
import java.util.Hashtable;
import java.io.IOException;
import java.io.Writer;

public class PackagesWriter extends HtmlWriter {

    public PackagesWriter(String anOutputDirectory,
			  String aTemplateDirectory,
			  Hashtable aKnownTypeList,
			  PackageDoc[] aPackageList,
			  int aPackageSize) {
	super(anOutputDirectory,aTemplateDirectory,"packages.html",aKnownTypeList);
	_packages = aPackageList;
	_packageSize = aPackageSize;
    }

    protected void document() throws IOException {
	final Writer theStream = getOutputStream();
	copyTemplateHeader(theStream);
	title("End User Manual",theStream);
	section(theStream,"Package Summary",null);
	theStream.write("<TABLE>\n");
	Utility.quickSort(_packages,0,_packageSize-1);
	for ( int theRank = 0; theRank < _packageSize; theRank++ ) {
	    theStream.write("<TR VALIGN=\"TOP\"><TD><UL><LI>");
	    linkToPackage(theStream,_packages[theRank]);
	    theStream.write("</UL></TD><TD>" + 
			    shortComment(_packages[theRank]) +
			    "</TD></TR>\n");
	}
	theStream.write("</TABLE>\n");
	endSection(theStream);
	copyTemplateFooter(theStream);	
    }

    public String getOutputFileName() {
	return "packages.html";
    }

    private PackageDoc[] _packages;
    private int _packageSize;
    
}
