//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.error;

/**
 * [PENDING: update the comments] DefaultErrorHandler.
 */

public final class DefaultErrorHandler extends ErrorHandler {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/error/DefaultErrorHandler.java,v $ $revision$ $Date: 1998/11/02 15:54:51 $ Copyright 1998 INRIA.";
  
    private DefaultErrorHandler() {
	super();
    }

    public final boolean canHandleError() {
	return true;
    }
  
    public final boolean hasNextErrorHandler() {
	return false;
    }
  
    public final ErrorHandlerInterface getNextErrorHandler() {
	return null;
    }

    public final void manageFatalError(Error anError) {
	final String theMessage = anError.getMessage();
	if ( theMessage != null ) {
	    System.err.println("*** ERROR *** : " + theMessage);
	}
	throw anError;
    }

    public final void manageWarning(Warning aWarning) {
	final String theMessage = aWarning.getMessage();
	if ( theMessage != null ) {
	    System.err.println("*** WARNING *** : " + theMessage);
	}
    }

    public final static DefaultErrorHandler INSTANCE = new DefaultErrorHandler();
    public static ErrorHandlerInterface DEFAULT = null;
  
}
