//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.event;

import figue.InteractiveFacade;
import figue.path.LinearPath;
import figue.path.PathInterface;

import java.awt.event.MouseEvent;

/**
 * [PENDING: update the comments] DefaultMouseListener.
 */

public class DefaultMouseListener extends DefaultListener implements PointingListenerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/event/DefaultMouseListener.java,v $ $revision$ $Date: 1998/11/02 15:54:53 $ Copyright 1998 INRIA.";
 
    public DefaultMouseListener(InteractiveFacade aFacade) {
	super(aFacade);
    }
 
    public void mouseEntered(PointingEvent anEvent) {
	getFacade().requestFocus(); /// BEURK
    }
    public void mouseExited(PointingEvent anEvent) {
    }

    public void mousePressed(PointingEvent anEvent) {
    }
    public void mouseReleased(PointingEvent anEvent) {
    }
    public void mouseClicked(PointingEvent anEvent) {
	final MouseEvent theLowLevelEvent = anEvent.getAwtEvent();
	switch ( theLowLevelEvent.getClickCount() ) {
	case 1: {
	    final PathInterface thePath = anEvent.getPath();
	    if ( thePath == null ) {
		break;
	    }
	    PathInterface theExtendedPath = new LinearPath();
	    theExtendedPath.addChild(thePath);
	    if ( theLowLevelEvent.isShiftDown() ) {
		modifyCurrentSelection(theExtendedPath);
	    }
	    else {
		setCurrentSelection(theExtendedPath);
	    }
	    break;
	}
	case 2: {
	    PathInterface theExtendedPath = new LinearPath();
	    theExtendedPath.addChild(anEvent.getPath());
	    setCurrentSelection(theExtendedPath);
	    break;
	}
	default: {
	    break;
	}
	}
    }

}

