//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.box.GlyphInterface;

public final class ActionNewLine extends Action {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/ActionNewLine.java,v $ $revision$ $Date: 1998/11/02 15:54:58 $ Copyright 1998 INRIA.";

    public ActionNewLine(GlyphInterface aGlyph,int anHeight, int aCost) {
	super("NewLine",
	      true, // Better than none ?
	      true, // Better than shrink ?
	      true, // Better than shrink son ?
	      true); // Better than new line ?
	_place = aGlyph;
	_location = anHeight;
	_cost = aCost;
    }
  
    public ActionNewLine(GlyphInterface aGlyph) {
	this(aGlyph,-1,-1);
    }

    public ActionNewLine(int anHeight, int aCost) {
	this(null,anHeight,aCost);
    }

    public final void execute(GlyphInterface aGlyph,
			      DecalageInterface aDecalage,
			      AlternativeInterface anAlternative) 
	throws TooSmallPageException, StopFormattingSonsException{
	aGlyph.executeActionNewLine(aDecalage.getBrother());
      
    }

    public final boolean isComplient(GlyphInterface aGlyph) {
	return aGlyph.isActionNewLineComplient(this);
    }

    public final boolean isBetterThan(ActionInterface anAction) {
	return ( ! anAction.isBetterThanNewLine(this) );
    }
  
    public final boolean isBetterThanNewLine(ActionNewLine anActionNewLine) {
	return ( anActionNewLine._cost <= _cost );
    }

    public GlyphInterface getPlace() {
	return _place;
    }
  
    public final int getIndex() {
	return _location;
    }
  
    public final int getCost() {
	return _cost;
    }
  
    public final void setCost(int aValue) {
	_cost = aValue; 
    }

    public String toString() {
	StringBuffer theResult = new StringBuffer("Action<NewLine");
	if ( _place != null ) {
	    theResult.append(";").append(_place.toString());
	}
	if ( _location != -1 ) {
	    theResult.append(";").append(_location)
		.append(";").append(_cost);
	}
	theResult.append(">");
	return theResult.toString();
    }
  
    private GlyphInterface _place;
    private int _location;
    private int _cost;
  
}
