//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.box.GlyphInterface;

public final class ActionShrink extends Action {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/ActionShrink.java,v $ $revision$ $Date: 1998/11/02 15:54:58 $ Copyright 1998 INRIA.";
  
    private ActionShrink() {
	super("Shrink",
	      true, // Better than none ?
	      true, // Better than shrink ?
	      true, // Better than shrink son ?
	      true); // Better than new line ?
    }

    public final void execute(GlyphInterface aGlyph,
			      DecalageInterface aDecalage,
			      AlternativeInterface anAlternative)
	throws TooSmallPageException, StopFormattingSonsException {
	aGlyph.executeActionShrink();
    }

    public final boolean isComplient(GlyphInterface aGlyph) {
	return aGlyph.isActionShrinkComplient();
    }

    public final boolean isBetterThan(ActionInterface anAction) {
	return ( ! anAction.isBetterThanShrink(this) );
    }

    public final static ActionShrink INSTANCE = new ActionShrink();
  
}
