//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.box.GlyphInterface;
import figue.geometry.Dimension;
import figue.internal.ContextInterface;

public interface DistanceInterface extends ValueInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/DistanceInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:00 $ Copyright 1998 INRIA.";

    public int getValue();
    public int getEagerValue();

    public DistanceInterface getDistance(); /// BEURK ...
      
    public void setDecalage(DecalageInterface aDecalage);
    public DecalageInterface getDecalage();
  
    public boolean isSufficientFor(Dimension aSize);
    public void checkBefore(AlternativeInterface anAlternative)
	throws StopFormattingSonsException;
    public void checkAfter(GlyphInterface aGlyph,
			   AlternativeInterface anAlternative)
	throws StopFormattingSonsException;

    public DistanceInterface lowerLevel(ContextInterface aContext,
					GlyphInterface aGlyph);
    public void newBrother(ContextInterface aContext,GlyphInterface aGlyph);
    public void upperLevel(ContextInterface aContext);

    public void clearDependent();
    public void dispose(ContextInterface aContext);
  
}
