//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.internal.ContextInterface;
import figue.box.GlyphInterface;
import figue.error.ImplementationError;
import figue.error.ShouldNotBeCalledError;

public final class ImmediateDistance extends Distance {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/ImmediateDistance.java,v $ $revision$ $Date: 1998/11/02 15:55:03 $ Copyright 1998 INRIA.";
  
    public ImmediateDistance(int aValue) {
	super(null);
	_value = aValue;
    }
  
    public final DistanceInterface getDistance() {
	throw new ImplementationError("Unexpected"); /// BEURK ...
    }

    public final void setValue(int aValue) {
	_value = aValue;
	notifyEagerChange();
    }
  
    public final int getValue() {
	return _value;
    }

    public final int getEagerValue() {
	return _value;
    }

    public final DistanceInterface lowerLevel(ContextInterface aContext,
					      GlyphInterface aGlyph) {
	DistanceInterface theDistance = super.lowerLevel(aContext,aGlyph);
	addDependent((ComputedValueInterface)theDistance);
	return theDistance;
    }

    public final void newBrother(ContextInterface aContext,
				 GlyphInterface aGlyph) {
	throw new ShouldNotBeCalledError();
    }

    public final void upperLevel(ContextInterface aContext) {
	;
    }

    public final void clearDependent() {
	;
    }
  
    public final void tryAlternative(AlternativeInterface anAlternative) {
	;
    }

    public final void dispose(ContextInterface aContext) {
	_value = -1;
	super.dispose(aContext);
    }
  
    public final String toString() {
	StringBuffer theResult = new StringBuffer("ImmediateDistance<");
	theResult.append(_value).append(">");
	return theResult.toString();
    }
  
    private int _value;
  
}
