//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.box.GlyphInterface;
import figue.internal.ContextInterface;
import figue.internal.Globals;

public final class LazyDecalageToBrother extends LazyDecalage {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/LazyDecalageToBrother.java,v $ $revision$ $Date: 1998/11/02 15:55:03 $ Copyright 1998 INRIA.";
  
    public LazyDecalageToBrother(GlyphInterface aFather,
				 GlyphInterface aBrother,
			  DecalageInterface aDecalage) {
	super(aFather,aDecalage);
	_brother = aBrother;
    }
    
    public void init(GlyphInterface aFather,
		     GlyphInterface aBrother,
		     DecalageInterface aDecalage) {
	super.init(aFather,aDecalage);
	_brother = aBrother;
    }

    public final boolean hasBrother() {
	return ( _brother != null );
    }

    public GlyphInterface getBrother() {
	return _brother;
    }

    public final void setBrother(GlyphInterface aGlyph) {
	_brother = aGlyph;
    }

    protected final int evalValue() {
	return getFather().computeDecalage2D(_brother,getDecalage());
    }

    public final void tryAlternative(AlternativeInterface anAlternative) {
	if ( Globals.DEBUG_FORMAT_HISTORY ) {
	    System.out.println("LazyDecalageToBrother.tryAlternative"); 
	}
	getFather().tryAlternativeForDecalage(this,anAlternative);
    }

    public final void dispose(ContextInterface aContext) {
	_brother = null;
	reinit();
	aContext.disposeLazyDecalageToBrother(this);
    }
  
    private GlyphInterface _brother;

}
