//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.internal.ContextInterface;
import figue.geometry.Point;
import figue.geometry.Dimension;

public interface ModificationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/ModificationInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:04 $ Copyright 1998 INRIA.";
  
    public boolean isModified();
    public boolean isOriginModified();
    public boolean isSizeModified();
    public boolean isSonModified();
  
    public Point getOrigin();
    public void setOrigin(int x, int y);
    public Dimension getSize();
    public void setSize(Dimension aDimension);
  
    public int getSonModifiedRank();
    public void setSonModifiedRank(int aRank);
    public boolean isSonClean();
    public void setSonClean(boolean aFlag);

    public void dispose(ContextInterface aContext);

}
