//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.geometry.Dimension;
import figue.geometry.Point;
import figue.error.ShouldNotBeCalledError;
import figue.internal.ContextInterface;

public final class NoModification implements ModificationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/NoModification.java,v $ $revision$ $Date: 1998/11/02 15:55:05 $ Copyright 1998 INRIA.";
  
    private NoModification() {
	;
    }
  
    public final boolean isModified() {
	return false;
    }
  
    public final boolean isOriginModified() {
	return false;
    }
  
    public final boolean isSizeModified() {
	return false;
    }

    public final boolean isSonModified() {
	return false;
    }

    public final Point getOrigin() {
	return null;
    }

    public final void setOrigin(int x, int y) {
	throw new ShouldNotBeCalledError();
    }
  
    public final Dimension getSize() {
	return null;
    }
  
    public final void setSize(Dimension aDimension) {
	throw new ShouldNotBeCalledError();
    }

    public final int getSonModifiedRank() {
	throw new ShouldNotBeCalledError();
    }

    public final void setSonModifiedRank(int aRank) {
	throw new ShouldNotBeCalledError();
    }

    public final boolean isSonClean() {
	throw new ShouldNotBeCalledError();
    }

    public final void setSonClean(boolean aFlag) {
	throw new ShouldNotBeCalledError();
    }

    public final void dispose(ContextInterface aContext) {
	;
    }
  
    public final String toString() {
	return "noModification<>";
    }
  
    public final static NoModification INSTANCE = new NoModification();
  
}
