//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.internal.ContextInterface;
import figue.box.GlyphInterface;

public abstract class StrategySetOrigin {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategySetOrigin.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";
  
    protected StrategySetOrigin(ContextInterface aContext) {
	_context = aContext;
    }
    protected StrategySetOrigin() {
	this(null);
    }
  
    public abstract void doAlgorithm(GlyphInterface aGlyph,int x, int y);

    public abstract StrategySetOrigin clone(ContextInterface aContext);

    public final void setContext(ContextInterface aContext) {
	_context = aContext;
    }
    protected final ContextInterface getContext() {
	return _context;
    }

    private ContextInterface _context;
  
    public final static StrategySetOrigin INCREMENTAL = new StrategySetOriginIncremental();
  
    public final static StrategySetOrigin NO_INCREMENTAL = new StrategySetOriginNoIncremental();
  
}

final class StrategySetOriginNoIncremental extends StrategySetOrigin {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategySetOrigin.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";

    public StrategySetOriginNoIncremental(ContextInterface aContext) {
	super(aContext);
    }
    public StrategySetOriginNoIncremental() {
	this(null);
    }
  
    public final void doAlgorithm(GlyphInterface aGlyph, int x, int y) {
	aGlyph.setOrigin(x,y);
    }

    public final StrategySetOrigin clone(ContextInterface aContext) {
	return new StrategySetOriginNoIncremental(aContext);
    }
  
}

final class StrategySetOriginIncremental extends StrategySetOrigin {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategySetOrigin.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";

    public StrategySetOriginIncremental(ContextInterface aContext) {
	super(aContext);
    }
    public StrategySetOriginIncremental() {
	this(null);
    }

    public final void doAlgorithm(GlyphInterface aGlyph, int x, int y) {
	aGlyph.resetOrigin(x,y,getContext());
    }

    public final StrategySetOrigin clone(ContextInterface aContext) {
	return new StrategySetOriginIncremental(aContext);
    }
  
}

