//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

public abstract class Value {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/Value.java,v $ $revision$ $Date: 1998/11/02 15:55:08 $ Copyright 1998 INRIA.";
  
    protected Value() {
	_dependent = null;
    }
  
    protected void init() {
	_dependent = null;
    }
  
    public final void notifyChange() {
	if ( _dependent != null ) {
	    _dependent.update();
	}
    }

    public final void notifyEagerChange() {
	if ( _dependent != null ) {
	    _dependent.updateEager();
	}
    }
  
    public final void addDependent(ComputedValueInterface aValue) {
	_dependent = aValue;
    }

    public final ComputedValueInterface getDependent() {
	return _dependent;
    }
  
    public final void removeDependent() {
	_dependent = null;
    }
  
    private  ComputedValueInterface _dependent;
  
}
