//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.geometry;

/**
 * [PENDING: update the comments] Transformer.
 * @level advanced
 */

public final class Transformer {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/geometry/Transformer.java,v $ $revision$ $Date: 1998/11/02 15:55:11 $ Copyright 1998 INRIA.";
  
    public Transformer(Point aPoint) {
	_x = aPoint.getX();
	_y = aPoint.getY();
    }

    public Transformer(int x, int y) {
	_x = x;
	_y = y;
    }
  
    public Transformer() {
	_x = 0;
	_y = 0;
    }

    public final void setLocation(Transformer aTransformer) {
	_x = aTransformer._x;
	_y = aTransformer._y;
    }

    public final void setLocation(int x, int y) {
	_x = x;
	_y = y;
    }
  
    public final void translate(int dx, int dy) {
	_x += dx;
	_y += dy;
    }
  
    public final void translate(Transformer aTransformer) {
	_x += aTransformer._x;
	_y += aTransformer._y;
    }

    public final void translate(Rectangle aRectangle) {
	_x += aRectangle.getX();
	_y += aRectangle.getY();
    }
  
    public final int applyToX(int x) {
	return x + _x;
    }
  
    public final int applyToY(int y) {
	return y + _y;
    }
  
    public final void applyTo(Rectangle aRectangle) {
	aRectangle.translate(_x,_y);
    }
  
    public final String toString() {
	StringBuffer theResult = new StringBuffer("Transformer<");
	theResult.append(_x).append("/").append(_y).append(">");
	return theResult.toString();
    }
  
    private int _x;
    private int _y;

}


 
