//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.io.xml;

import antlr.CommonToken;
import java.util.Enumeration;

final class TokenWithAttributes extends CommonToken {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/io/xml/TokenWithAttributes.java,v $ $revision$ $Date: 1998/11/02 15:55:19 $ Copyright 1998 INRIA.";
    
    public TokenWithAttributes(int t, String s, Attributes anAttributeList) {
	super(t,s);
	_attributes = anAttributeList;
    }

    public final Attributes getAttributes() {
	return _attributes;
    }

    public final Enumeration getAttributeNames() {
	if ( _attributes != null ) {
	    return _attributes.getAttributeNames();
	}
	else {
	    return null;
	}
    }

    public final boolean hasAttributes() {
	return ( ( _attributes != null ) && _attributes.hasAttributes() );
    }

    public final boolean hasRedefinedAttributes() {
	return ( ( _attributes != null ) && _attributes.hasRedefinedAttributes() );
    }

    public final void clear() {
	if ( _attributes != null ) {
	    _attributes.clear();
	}
    }

    private Attributes _attributes;

}
