//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.multithread;

import figue.internal.Globals;

public final class ThreadCondition implements ThreadConditionInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/multithread/ThreadCondition.java,v $ $revision$ $Date: 1998/11/02 15:55:26 $ Copyright 1998 INRIA.";
  
    public ThreadCondition(String aName) {
	_name = aName;
    }
  
    public final synchronized void await() {
	if ( Globals.DEBUG_MULTI_THREAD ) {
	    System.out.println("- await " + toString());
	}
	try {
	    wait();
	}
	catch ( InterruptedException anException ) {
	    ;
	}
    }
  
    public final synchronized void signal() {
	if ( Globals.DEBUG_MULTI_THREAD ) {
	    System.out.println("+ signal " + toString());
	}
	notifyAll();
    }
  
    public final String toString() {
	StringBuffer theResult = new StringBuffer("Condition<");
	theResult.append(_name).append(">");
	return theResult.toString();
    }

    private String _name;
  
}
