//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.selection.SelectionInterface;
import figue.box.GlyphInterface;
import figue.internal.PathVisitorInterface;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] InverseSelection.
 */

public final class InverseSelection implements PathOperationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/InverseSelection.java,v $ $revision$ $Date: 1998/11/02 15:55:28 $ Copyright 1998 INRIA.";
  
    public InverseSelection(SelectionInterface aSelection) {
	super();
	_selection = aSelection; 
    }
  
    public final Object clone() { 
	return new InverseSelection(_selection); 
    }
  
    public final SelectionInterface getSelection() { 
	return _selection; 
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath) {
	aVisitor.inverseSelection(this,aGlyph,aSelectionPath);
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph) {
	aVisitor.inverseSelection(this,aGlyph);
    }
  
    public final String toString() { 
	StringBuffer theResult = new StringBuffer("InverseSelection<");
	theResult.append(_selection.getName()).append(">");
	return theResult.toString();
    }

    public final void writeState(Writer anOutput) throws IOException {
	anOutput.write("<InverseSelection Name=\"");
	anOutput.write(_selection.getName());
	anOutput.write("\"/>");
    }
    
    private SelectionInterface _selection;

}
