//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.internal.PathVisitorInterface;
import figue.box.GlyphInterface;
import figue.io.ExternalizableAsXMLInterface;

/**
 * [PENDING: update the comments] PathInterface.
 */

public interface PathInterface extends ExternalizableAsXMLInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/PathInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:31 $ Copyright 1998 INRIA.";
    
    public int getRank();
    public void setRank(int aValue);
    public void addOperation(PathOperationInterface anOperation);
    public PathOperationInterface getOperation(int aRank);
    public int numberOfOperation();
    public void addChild(PathInterface aChild);
    public void insertChild(PathInterface aChild, int aRank);
    public PathInterface getChild(int aRank);
    public int numberOfChildren();
    
    /**
     * [PENDING: update the comments] accept
     * @level advanced
     */
    public void accept(PathVisitorInterface aVisitor,
		       GlyphInterface aGlyph,
		       SelectionPathInterface aSelectionPath);
    /**
     * [PENDING: update the comments] accept
     * @level advanced
     */
    public void accept(PathVisitorInterface aVisitor,
		       GlyphInterface aGlyph);
    /**
     * [PENDING: update the comments] internalToString
     * @level advanced
     */
    public void internalToString(StringBuffer aBuffer,
				 String aPath);
    
}

