//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.box.GlyphInterface;
import figue.internal.PathVisitorInterface;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] RemoveGlyph.
 */

public final class RemoveGlyph implements PathOperationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/RemoveGlyph.java,v $ $revision$ $Date: 1998/11/02 15:55:31 $ Copyright 1998 INRIA.";
  
    public RemoveGlyph(int rank) {
	_rank = rank;
    }
  
    public final Object clone() { 
	return new RemoveGlyph(_rank); 
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath) {
	aVisitor.removeGlyph(this,aGlyph,aSelectionPath);
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph) {
	aVisitor.removeGlyph(this,aGlyph);
    }
    
    public final int getRank() { 
	return _rank; 
    }
  
    public final String toString() { 
	return "removeGlyph<"+_rank+">";
    }

    public final void writeState(Writer anOutput) throws IOException {
	anOutput.write("<RemoveGlyph Rank=\"");
	anOutput.write(Integer.toString(_rank));
	anOutput.write("\"/>");
    }
  
    private int _rank;
  
}
