//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

import figue.error.ShouldNotBeCalledError;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] ColorDefered.
 * @level advanced
 */

public final class ColorDefered implements ColorInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/ColorDefered.java,v $ $revision$ $Date: 1998/11/02 15:55:35 $ Copyright 1998 INRIA.";
  
    public ColorDefered(String aName,
			ColorInitializerInterface aResourceInitializer) {
	_name = aName;
	_resourceInitializer = aResourceInitializer;
    }
  
    public final String getName() {
	return _name;
    }

    public final java.awt.Color getAwtColor() {
	return _resourceInitializer.initResource(_name).getAwtColor();
    }

    public final int getRed() {
	return _resourceInitializer.initResource(_name).getRed();
    }
  
    public final int getGreen() {
	return _resourceInitializer.initResource(_name).getGreen();
    }
  
    public final int getBlue() {
	return _resourceInitializer.initResource(_name).getBlue();
    }
  
    public final String toString() {
	StringBuffer theResult = new StringBuffer("ColorDefered<");
	theResult.append(_name).append(">");
	return theResult.toString();
    }

    public void writeState(Writer anOutput) throws IOException {
	throw new ShouldNotBeCalledError();
    }

    private String _name;
    private ColorInitializerInterface _resourceInitializer;
  
}
