//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

/**
 * [PENDING: update the comments] FontInitializer.
 * @level advanced
 */

public final class FontInitializer extends ResourceInitializer implements FontInitializerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/FontInitializer.java,v $ $revision$ $Date: 1998/11/02 15:55:37 $ Copyright 1998 INRIA.";
  
    public FontInitializer(FontOwnerInterface anOwner) {
	super();
	_owner = anOwner;
    }

    public final ResourceOwnerInterface getOwner() {
	return _owner;
    }
  
    public FontInterface initResource(String aName) {
	FontInterface theFont = newFont(_owner,aName);
	_owner.setFont(theFont);
	return theFont;
    }
  
    public final String getName() {
	return "Font";
    }

    private FontOwnerInterface _owner;
  
}
