//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.selection;

import figue.resource.ColorInterface;
import figue.resource.ColorOwnerInterface;
import figue.resource.BackgroundOwnerInterface;
import figue.FacadeInterface;
import figue.io.ExternalizableInterface;
import figue.error.ErrorHandlerInterface;

/**
 * [PENDING: update the comments] SelectionInterface.
 */

public interface SelectionInterface extends ErrorHandlerInterface, ColorOwnerInterface, BackgroundOwnerInterface, ExternalizableInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/selection/SelectionInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:45 $ Copyright 1998 INRIA.";
 
    public String getName();
    public void setVisible(boolean aFlag);
    public boolean isVisible();
    public int getPriority();
    public ColorInterface getColor();
    public ColorInterface getBackground();
    public HighlighterInterface getHighlighter();
    public void setHighlighter(HighlighterInterface anHighlighter);
    public FacadeInterface getFacade();

}
