//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.tutorial;

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                             *** DO NOT EDIT ***                           //
//                                                                           //
//  Generated from file : java/tutorial/template/TutorialAwtSwingApplet.java //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

import figue.*;
import figue.event.*;
import figue.resource.*;
import figue.utility.DefaultApplet;

abstract class TutorialApplet extends DefaultApplet {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/tutorial/template/TutorialAwtSwingApplet.java,v $ $revision$ $Date: 1998/11/02 15:56:01 $ Copyright 1998 INRIA.";
  
    public TutorialApplet() {
	super();
    }

    public final void init() {
	setBackground(java.awt.Color.lightGray);
	initTutorial();
	Thread.currentThread().yield();
    }

    protected abstract void initTutorial();

    public String[][] getParameterInfo() {
	return PARAMETERS_INFO;
    }
  
    public final void setAppletParameters(FacadeInitializer aParameterList) {
	String theValue = getParameter(RIGHT_MARGIN);
	if ( theValue != null ) {
	    try {
		final int theIntValue = Integer.parseInt(theValue);
		if ( theIntValue > 0 ) {
		    aParameterList.setFormattingWidth(theIntValue);
		}
	    }
	    catch ( NumberFormatException anException ) {
		;
	    }
	}
	theValue = getParameter(INITIAL_FONT);
	if ( theValue != null ) {
	    theValue.trim();
	    if ( theValue.length() > 0 ) {
		aParameterList.setInitialFont(theValue);
	    }
	}
	theValue = getParameter(INITIAL_COLOR);
	if ( theValue != null ) {
	    theValue.trim();
	    if ( theValue.length() > 0 ) {
		aParameterList.setInitialColor(theValue);
	    }
	}
	theValue = getParameter(INITIAL_BACKGROUND);
	if ( theValue != null ) {
	    theValue.trim();
	    if ( theValue.length() > 0 ) {
		aParameterList.setInitialBackground(theValue);
	    }
	}
    }

    public final void initStandardResources(FacadeInterface aFacade) {
	defineFontIfNeeded(aFacade,"big",FontFamily.COURIER,FontStyle.BOLD,24,false);
	defineFontIfNeeded(aFacade,"standard",FontFamily.TIMES_ROMAN,FontStyle.PLAIN,13,false);
	defineFontIfNeeded(aFacade,"small",FontFamily.TIMES_ROMAN,FontStyle.PLAIN,9,false);
	defineColorIfNeeded(aFacade,"black",BasicColor.BLACK);
	defineColorIfNeeded(aFacade,"white",BasicColor.WHITE);
	defineColorIfNeeded(aFacade,"red",BasicColor.RED);
	defineColorIfNeeded(aFacade,"green",BasicColor.GREEN);
	defineColorIfNeeded(aFacade,"blue",BasicColor.BLUE);
	defineColorIfNeeded(aFacade,"gray",BasicColor.GRAY);
	defineColorIfNeeded(aFacade,"light gray",BasicColor.LIGHT_GRAY);
	defineColorIfNeeded(aFacade,"dark gray",BasicColor.DARK_GRAY);
	defineColorIfNeeded(aFacade,"cyan",BasicColor.CYAN);
	defineColorIfNeeded(aFacade,"magenta",BasicColor.MAGENTA);
	defineColorIfNeeded(aFacade,"orange",BasicColor.ORANGE);
	defineColorIfNeeded(aFacade,"pink",BasicColor.PINK);
	defineColorIfNeeded(aFacade,"yellow",BasicColor.YELLOW);
    }

    private final void defineFontIfNeeded(FacadeInterface aFacade,
					  String aMnemonic,
					  FontFamily aFamily,
					  FontStyle aStyle,
					  int aPointSize,
					  boolean anUnderlinedFlag) {
	try {
	    aFacade.getFont(aMnemonic);
	}
	catch ( WrongResourceException anException ) {
	    try {
		aFacade.doGetFont(aMnemonic,aFamily,aStyle,aPointSize,anUnderlinedFlag);
	    }
	    catch ( WrongResourceException anotherException ) {
		;
	    }
	}
    }

    private final void defineColorIfNeeded(FacadeInterface aFacade,
					   String aMnemonic,BasicColor aColor) {
	try {
	    aFacade.getColor(aMnemonic);
	}
	catch ( WrongResourceException anException ) {
	    try {
		aFacade.doGetColor(aMnemonic,aColor);
	    }
	    catch ( WrongResourceException anotherException ) {
		;
	    }
	}
    }

    protected final void setDefaultKeyListener(InteractiveFacade aFacade) {
	aFacade.addKeyListener(new DefaultKeyListener(aFacade));
	final InteractiveFacade theFacade = aFacade;
	aFacade.addPointingListener(new PointingListenerInterface() {
	    public final void mouseEntered(PointingEvent anEvent) {
		theFacade.requestFocus();
	    }
	    public final void mouseExited(PointingEvent anEvent) {
	    }
	    public final void mousePressed(PointingEvent anEvent) {
	    }
	    public final void mouseReleased(PointingEvent anEvent) {
	    }
	    public final void mouseClicked(PointingEvent anEvent) {
	    }
	});
    }
  
    private final static String RIGHT_MARGIN = "RIGHT_MARGIN";
    private final static String INITIAL_FONT = "INITIAL_FONT";
    private final static String INITIAL_COLOR = "INITIAL_COLOR";
    private final static String INITIAL_BACKGROUND = "INITIAL_BACKGROUND";

    private final static String PARAMETERS_INFO[][] = {
	{ RIGHT_MARGIN,       "positive int",                        "Right margin" },
	{ INITIAL_FONT,       "string",                              "Initial font" },
	{ INITIAL_COLOR,      "string",                              "Initial foreground" },
	{ INITIAL_BACKGROUND, "string",                              "Initial background" }
    };
  
}
