//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.tutorial;

import java.awt.GridLayout;

import figue.*;
import figue.box.*;
import figue.path.*;
import figue.resource.*;

public final class Tutorial_19 extends TutorialApplet {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/tutorial/Tutorial_19.java,v $ $revision$ $Date: 1998/11/02 15:55:52 $ Copyright 1998 INRIA.";

    protected final void initTutorial() {
	setLayout(new GridLayout(1,1));
	_facade = new AWTFacade(getParameters());
	add(_facade.getAwtComponent());
	setDefaultKeyListener(_facade);
	initResources();
	buildBox();
    }

    public final void destroy() {
	_facade.disposeWhenInactive();
	_facade = null;
	super.destroy();
    }

    private final void initResources() {
	try {
 	    _facade.doGetFont(Constants.DEFAULT_FONT,FontFamily.TIMES_ROMAN,FontStyle.BOLD,26,false);
	    _facade.doGetColor(Constants.DEFAULT_COLOR,BasicColor.GREEN);
	    _facade.doGetColor(Constants.DEFAULT_BACKGROUND,BasicColor.YELLOW);
	}
	catch ( WrongResourceException anException ) {
	    ;
	}
	initStandardResources(_facade);
    }

    private final void buildBox() {
	final GlyphInterface theLine = new Horizontal(15);
	theLine.addChild(Atom.newAtom("It's"));
	theLine.addChild(Atom.newAtom('a'));
	theLine.addChild(Atom.newAtom("wonderful"));
	theLine.addChild(Atom.newAtom("life"));
	theLine.addChild(Atom.newAtom("!!"));
	PathInterface thePath = new Path();
	thePath.addOperation(new InsertGlyph(theLine,0));
	_facade.buildInit(thePath);
	_facade.buildComplete();
    }

    private final FacadeInitializer getParameters() {
	FacadeInitializer theParameters = new FacadeInitializer();
	theParameters.setFormattingWidth(475);
	theParameters.setInitialColor("My color");
	theParameters.setInitialBackground("My background");
	theParameters.setInitialFont("My font");
	setAppletParameters(theParameters);
	return theParameters;
    }

    private AWTFacade _facade;
  
}

