//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.tutorial;

import java.awt.GridLayout;

import figue.*;
import figue.box.*;
import figue.path.*;
import figue.resource.*;

public final class Tutorial_9 extends TutorialApplet {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/tutorial/Tutorial_9.java,v $ $revision$ $Date: 1998/11/02 15:56:00 $ Copyright 1998 INRIA.";

    protected final void initTutorial() {
	setLayout(new GridLayout(1,1));
	_facade = new AWTFacade(getParameters());
	add(_facade.getAwtComponent());  
	setDefaultKeyListener(_facade);
	initResources();
	buildBox();
    }

    public final void destroy() {
	_facade.disposeWhenInactive();
	_facade = null;
	super.destroy();
    }

    private final void buildBox() {
	final GlyphInterface theColumn = new Vertical(0,15);
	theColumn.addChild(Atom.newAtom("INTERWORD " + INTERWORD + " IN PIXEL"));
	GlyphInterface theContext = new ChangeGraphicalContextAnonymous("italic","blue","yellow");
	theColumn.addChild(theContext);
	GlyphInterface theLine = new Horizontal(new Measure(INTERWORD,UnitInterface.PIXEL));
	theContext.addChild(theLine);
	fill(theLine);
	theContext = new ChangeGraphicalContextAnonymous("big","red","green");
	theColumn.addChild(theContext);
	theLine = new Horizontal(new Measure(INTERWORD,UnitInterface.PIXEL));
	theContext.addChild(theLine);
	fill(theLine);
	theColumn.addChild(Atom.newAtom("INTERWORD " + INTERWORD + " IN BLANK TENTH"));
	theContext = new ChangeGraphicalContextAnonymous("italic","blue","yellow");
	theColumn.addChild(theContext);
	theLine = new Horizontal(new Measure(INTERWORD,UnitInterface.BLANK_TENTH));
	theContext.addChild(theLine);
	fill(theLine);
	theContext = new ChangeGraphicalContextAnonymous("big","red","green");
	theColumn.addChild(theContext);
	theLine = new Horizontal(new Measure(INTERWORD,UnitInterface.BLANK_TENTH));
	theContext.addChild(theLine);
	fill(theLine);
	PathInterface thePath = new Path();
	thePath.addOperation(new InsertGlyph(theColumn,0));
	_facade.buildInit(thePath);
	_facade.buildComplete();
    }

    private final void fill(GlyphInterface aLine) {
	aLine.addChild(Atom.newAtom("It's"));
	aLine.addChild(Atom.newAtom('a'));
	aLine.addChild(Atom.newAtom("wonderful"));
	aLine.addChild(Atom.newAtom("life"));
	aLine.addChild(Atom.newAtom("!!"));
    }

    private final void initResources() {
	try {
	    _facade.doGetFont(Constants.DEFAULT_FONT,FontFamily.TIMES_ROMAN,FontStyle.PLAIN,15,false);
	    _facade.doGetColor(Constants.DEFAULT_COLOR,BasicColor.BLUE);
	    _facade.doGetColor(Constants.DEFAULT_BACKGROUND,BasicColor.WHITE);
	    _facade.doGetFont("italic",FontFamily.TIMES_ROMAN,FontStyle.BOLD_ITALIC,24,false);
	    _facade.doGetFont("big",FontFamily.TIMES_ROMAN,FontStyle.BOLD,46,false);
	    _facade.doGetColor("yellow",BasicColor.YELLOW);
	    _facade.doGetColor("blue",BasicColor.BLUE);
	    _facade.doGetColor("red",BasicColor.RED);
	    _facade.doGetColor("green",BasicColor.GREEN);
	}
	catch ( WrongResourceException anException ) {
	    ;
	}
	initStandardResources(_facade);
    }
    
    private final FacadeInitializer getParameters() {
	FacadeInitializer theParameters = new FacadeInitializer();
	theParameters.setFormattingWidth(1900);
	setAppletParameters(theParameters);
	return theParameters;
    }

    private AWTFacade _facade;
    private final static int INTERWORD = 10;

}

