//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.utility;

final class JavaVersion {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/utility/JavaVersion.java,v $ $revision$ $Date: 1998/11/02 15:56:02 $ Copyright 1998 INRIA.";

    public JavaVersion(double aVersion, boolean aSwingFlag) {
	super();
	_version = aVersion;
	_swingFlag = aSwingFlag;
    }

    public JavaVersion(double aVersion) {
	this(aVersion,false);
    }

    public JavaVersion() {
	this(1.1);
    }
    
    public final double getVersion() {
	return _version;
    }

    public final boolean isSwingCompliant() {
	return _swingFlag;
    }

    private double _version;
    private boolean _swingFlag;

}
