//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.various;

import figue.*;
import figue.box.*;
import figue.resource.*;
import figue.event.*;
import figue.path.*;
import figue.selection.*;
import figue.io.*;
import figue.io.xml.*;

import java.util.Enumeration;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.MouseEvent;
import java.awt.Graphics;
import java.awt.AWTEvent;
import java.awt.Frame;
import java.awt.Button;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Hashtable;
import java.awt.Panel;
import java.awt.Choice;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
//import com.sun.java.swing.JFrame;
import javax.swing.JFrame;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.OutputStreamWriter;

import java.net.URL;
import java.net.MalformedURLException;

import antlr.CommonAST;
import antlr.collections.AST;
import antlr.DumpASTVisitor;

import java.io.FileInputStream;
import java.io.DataInputStream;
import java.io.FileNotFoundException;
import antlr.ParserException;

public final class Test {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/various/Test.java,v $ $revision$ $Date: 1998/11/02 15:56:04 $ Copyright 1998 INRIA.";

    public final static void main(String[] theArgs) {
	if ( theArgs.length == 3 ) {
	    try {
 		AWTFacade theFacade = new AWTFacade(new DataInputStream(new FileInputStream (theArgs[2])));
	    } catch(FileNotFoundException e) {
		System.out.println("exception: "+e);
	    }
	    catch(ParserException e) {
		System.out.println("exception: "+e);
	    }
	    catch ( IOException e ) {
		System.out.println("exception: "+e);
	    }
	    System.exit(0);
	}
	else {
	    // 	    if ( theArgs.length != 2 ) {
	    // 		System.exit(-1);
	    // 	    }
	    // 	}
	    if ( theArgs[0].equals("awt") ) {
		TestThread.TYPE_TEST = TestThread.AWT;
	    }
	    else {
		if ( theArgs[0].equals("ascii") ) {
		    TestThread.TYPE_TEST = TestThread.ASCII;
		}
		else {
		    if ( theArgs[0].equals("ps") ) {
			TestThread.TYPE_TEST = TestThread.PS;
		    }
		    else {
			if ( theArgs[0].equals("swing") ) {
			    TestThread.TYPE_TEST = TestThread.SWING;
			}
			else {
			    System.exit(-1);
			}
		    }
		}
	    }
	    if ( theArgs[1].equals("mini")) {
		TestThread.MINI_TEST_FLAG = true;
	    }
	    else {
		if ( theArgs[1].equals("big") ) {
		    ;
		}
		else {
		    if ( theArgs[1].equals("xml") ) {
			TestThread.XML_TEST_FLAG = true;
		    }
		    else {
			TestThread.ALPHABET_TEST_FLAG = true;
			try {
			    TestThread.ITERATIONS = Math.abs(Integer.parseInt(theArgs[1]));
			    if ( TestThread.ITERATIONS == 0 ) {
				TestThread.ITERATIONS++;
			    }
			}
			catch ( NumberFormatException anException ) {
			    ;
			}
		    }
		}
	    }
	    System.runFinalizersOnExit(true);
	    initialize();
	}
    }
    
    public final static void initialize() {
	final FacadeInitializer theInitializer = new FacadeInitializer();
	try {
	    theInitializer.setPortableFontLibrary(new URL("file://localhost/"+System.getProperty("user.dir")+"/web/jape/"));
	}
	catch ( MalformedURLException e ) {
	    e.printStackTrace();
	}
	final HighlighterInterface theDummyHighlighter1 = BarHighlighter.INSTANCE;
	final HighlighterInterface theDummyHighlighter2 = CornerHighlighter.INSTANCE;
	if ( TestThread.TYPE_TEST == TestThread.PS ) {
	    java.awt.Frame theDummyFrame = new java.awt.Frame();
	    theDummyFrame.add(new java.awt.Label("Dummy Frame"));
	    theDummyFrame.pack();
	    theDummyFrame.setVisible(true);
	    java.awt.PrintJob thePrintJob = null;
	    int theTry = 0;
	    while ( thePrintJob == null ) {
		thePrintJob = theDummyFrame.getToolkit().getPrintJob(theDummyFrame,"",null);
		try {
		    System.out.println("Can't get print job ... try[" + theTry +  "]");
		    if ( theTry > 10 ) {
			break;
		    }
		    Thread.sleep(500);
		}
		catch ( java.lang.InterruptedException e ) {
		    ;
		}
	    }
	    PSFacade theFacade = new PSFacade(thePrintJob,theInitializer);
	    initResources(theFacade);
	    theFacade.setMargins(2,2,3,3);
	    theFacade.addPrintListener(new PrintListenerInterface() {
		public void printInitiate(PrintEvent anEvent) {
		    System.out.println("-> printInitiate");
		}
		public void printAdvance(PrintEvent anEvent) {
		    System.out.println("-> printAdvance " + anEvent.getPageNumber() + " " +  anEvent.getPercentDone() + "%");
		}
		public void printDone(PrintEvent anEvent) {
		    System.out.println("-> printDone");
		}
	    });
	    _testThread = new PSTestThread(theFacade,theDummyFrame);
	    _testThread.start();
	}
	else {
	    if ( TestThread.TYPE_TEST == TestThread.ASCII ) {
//  		for ( int i = 0; i < 25; i++ ) {
		    ASCIIFacade theFacade = new ASCIIFacade(theInitializer);
		    initResources(theFacade);
		    _testThread = new ASCIITestThread(theFacade);
		    _testThread.start();
// 		    while ( ! theFacade.isDisposed() ) {
// 			Thread.yield();
// 		    }
// 		}
	    }
	    else {
		if ( ( TestThread.TYPE_TEST == TestThread.AWT ) || 
		     ( TestThread.TYPE_TEST == TestThread.SWING ) ) {
		    Frame theTest = null;
		    JFrame theJTest = null;
		    if ( TestThread.TYPE_TEST == TestThread.AWT ) {
			theTest = new Frame();
			theTest.setLayout(new BorderLayout());
			theTest.setSize(590,831);
		    }
		    else {
			theJTest = new JFrame();
			theJTest.getContentPane().setLayout(new BorderLayout());
			theJTest.setSize(590,831);
		    }
// 		    Frame theTest = new Frame();
// 		    theTest.setLayout(new BorderLayout());
//  		    theTest.setSize(590,831);
		    InteractiveFacade theFacade;
		    if ( TestThread.TYPE_TEST == TestThread.AWT ) {
			theFacade = new AWTFacade(theInitializer);
			_testThread = new InteractiveTestThread(theFacade,theTest);
		    }
		    else {
			theFacade = new SWINGFacade(theInitializer);
			_testThread = new InteractiveTestThread(theFacade,theJTest);
		    }
// 		    _testThread = new InteractiveTestThread(theFacade,theTest);
// 		    Panel thePanel = new Panel();
// 		    theTest.add(BorderLayout.NORTH,thePanel);
// 		    Button theButton = new Button("Quit");
// 		    theButton.addActionListener(new ActionListener() {
// 			public final void actionPerformed(ActionEvent anEvent) {
// 			    _testThread.dispose();
// 			    System.exit(0);
// 			}
// 		    });
// 		    thePanel.add(theButton);
// 		    theChoice = new Choice();
// 		    theChoice.add("Trace off");
// 		    theChoice.add("Trace on");
// 		    theChoice.select(0);
// 		    theChoice.addItemListener(new ItemListener() {
// 			public final void itemStateChanged(ItemEvent e) {
// 			    Runtime.getRuntime().traceMethodCalls(theChoice.getSelectedIndex() == 1);
// 			}
// 		    });
// 		    thePanel.add(theChoice);
// 		    theButton = new Button("Scroll To");
// 		    theButton.addActionListener(new ActionListener() {
// 			public final void actionPerformed(ActionEvent anEvent) {
// 			    try {
// 				_testThread.getFacade().insureVisible(getPathForSelection(_testThread.getFacade().getSelectionPath(),
// 											  _testThread.getFacade().getSelection("CURRENT")));
// 			    }
// 			    catch ( WrongSelectionException anException ) {
// 				;
// 			    }
// 			}
// 		    });
// 		    thePanel.add(theButton);
		    
		    if ( TestThread.TYPE_TEST == TestThread.AWT ) {
			theTest.add(BorderLayout.CENTER,theFacade.getAwtComponent());
			theTest.setVisible(true);
		    }
		    else {
			theJTest.getContentPane().add(theFacade.getAwtComponent(),BorderLayout.CENTER);
			theJTest.setVisible(true);
					    
		    }
// 		    theTest.add(BorderLayout.CENTER,theFacade.getAwtComponent());
//  		    theTest.setVisible(true);
 		    initResources(theFacade);
 		    theFacade.addKeyListener(new TestKeyListener(theFacade));
 		    theFacade.addPointingListener(new DefaultMouseListener(theFacade));
   		    theFacade.addPointingMotionListener(new DefaultMouseMotionListener(theFacade));
		    theFacade.addHyperlinkListener(new HyperlinkListenerInterface() {
			public void linkEntered(HyperlinkEvent anEvent) {
			    System.out.println("-> linkEntered" + anEvent.getHyperlink().getInfo());
			}
			public final void linkClicked(HyperlinkEvent anEvent) {
			    System.out.println("-> linkClicked");
			    anEvent.getHyperlink().setVisited();
			}
			public final void linkExited(HyperlinkEvent anEvent) {
			    System.out.println("-> linkExited");
			}
		    });
		    _testThread.start();
		}
	    }
	}
    }
    
    private final static PathInterface getPathForSelection(SelectionPathInterface aSelectionPath,
							   SelectionInterface aSelection) {
	PathInterface theResult = null;
	if ( aSelectionPath.contains(aSelection) ) {
	    theResult = new Path();
	    theResult.addOperation(MarkGlyph.INSTANCE);
	}
	final int theSize = aSelectionPath.numberOfChildren();
	SelectionPathInterface theCurrentSon;
	PathInterface theResultForSon;
	for ( int theRank = 0; theRank < theSize; theRank++ ) {
	    theCurrentSon = aSelectionPath.getChild(theRank);
	    theResultForSon = getPathForSelection(theCurrentSon,aSelection);
	    if ( theResultForSon != null ) {
		theResultForSon.setRank(theCurrentSon.getRank());
		if ( theResult == null ) {
		    theResult = new Path();
		}
		theResult.addChild(theResultForSon);
	    }
	}
	return theResult;
    }
    
    private final static void initResources(FacadeInterface aFacade) {
	try {
	    /***
		aFacade.doGetColor(Globals.DEFAULT_COLOR,BasicColor.MAGENTA);
		aFacade.doGetColor(Globals.DEFAULT_BACKGROUND,BasicColor.CYAN);
		aFacade.doGetFont(Globals.DEFAULT_FONT,FontFamily.TIMES_ROMAN,FontStyle.ITALIC,11,true);
	    ***/
	    aFacade.doGetColor(Constants.ACTIVE_LINK_COLOR,BasicColor.BLUE);
	    aFacade.doGetColor(Constants.VISITED_LINK_COLOR,BasicColor.MAGENTA);
	    aFacade.doGetColor(Constants.SELECTED_LINK_COLOR,BasicColor.RED);
	    //aFacade.doGetFont(Globals.ACTIVE_LINK_FONT,FontFamily.TIMES_ROMAN,FontStyle.ITALIC,24,true);
	    /***/
	    aFacade.doGetFont("helene",FontFamily.SYMBOL,FontStyle.PLAIN,20,true);
	    aFacade.doGetFont("gros italique",FontFamily.TIMES_ROMAN,FontStyle.ITALIC,24,false);
	    aFacade.doGetFont("tres gros gras",FontFamily.COURIER,FontStyle.BOLD,36,false);
	    aFacade.doGetFont("moyen",FontFamily.TIMES_ROMAN,FontStyle.PLAIN,11,false);
	    aFacade.doGetFont("petit italique",FontFamily.TIMES_ROMAN,FontStyle.ITALIC,11,false);
	    aFacade.doGetColor("noir",BasicColor.BLACK);
	    aFacade.doGetColor("jaune",BasicColor.YELLOW);
	    aFacade.doGetColor("bleu",BasicColor.BLUE);
	    aFacade.doGetColor("rose",BasicColor.PINK);
	    aFacade.doGetColor("blanc",BasicColor.WHITE);
	    aFacade.doGetColor("vert",BasicColor.GREEN);
	    aFacade.doGetColor("rouge",BasicColor.RED);
	    aFacade.doGetColor("gris leger",BasicColor.LIGHT_GRAY);
	    aFacade.doGetColor("cyan",BasicColor.CYAN);
	    aFacade.doGetStyle("grec",
			       aFacade.getFont("helene"),
			       aFacade.getColor("rouge"),
			       aFacade.getColor("bleu"));
	    aFacade.doGetStyle("sheetos",
			       aFacade.getFont("moyen"),
			       aFacade.getColor("noir"),
			       aFacade.getColor("jaune"));
	    aFacade.doGetStyle("blurp",
			       aFacade.getFont("gros italique"),
			       aFacade.getColor("jaune"),
			       aFacade.getColor("cyan"));
	    aFacade.doGetStyle("nega",
			       null,
			       aFacade.getColor("blanc"),
			       aFacade.getColor("noir"));
	    aFacade.doGetStyle("foo",
			       null,
			       aFacade.getColor("bleu"),
			       aFacade.getColor("gris leger"));
	    aFacade.doGetStyle("bar",
			       null,
			       aFacade.getColor("blanc"),
			       aFacade.getColor("gris leger"));
	    aFacade.doGetStyle("gee",
			       null,
			       aFacade.getColor("rouge"),
			       aFacade.getColor("gris leger"));
	}
	catch ( WrongResourceException anException ) {
	    anException.printStackTrace();
	    System.exit(-1);
	}
    }

    static TestThread _testThread;
    static Choice theChoice;
  
}

abstract class TestThread extends java.lang.Thread {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/various/Test.java,v $ $revision$ $Date: 1998/11/02 15:56:04 $ Copyright 1998 INRIA.";
  
    public TestThread() {
	setPriority(java.lang.Thread.NORM_PRIORITY);
    }
  
    public void dispose() {
	System.gc();
	System.runFinalization();
    }
  
    public abstract FacadeInterface getFacade();

    public abstract void endOfTest();
  
    public void run() {
	try {
	    final FacadeInterface theFacade = getFacade();
	    if ( ALPHABET_TEST_FLAG ) {
		GlyphInterface theBigV;
		theBigV = new Vertical(new Measure(0,UnitInterface.BLANK_TENTH),
				       new Measure(0,UnitInterface.LINE_TENTH));
		PathInterface theRoot = new Path();
		GlyphInterface theFirst = new Horizontal(new Measure(30,UnitInterface.BLANK_TENTH));
		theFirst.addChild(Atom.newAtom("***"));
		theFirst.addChild(Atom.newAtom("TEST"));
		theFirst.addChild(Atom.newAtom("***"));
		theFirst.addChild(Atom.newAtom("***"));
		Paragraph TEMPO = new Paragraph(new Measure(0,UnitInterface.BLANK_TENTH),
						new Measure(75,UnitInterface.BLANK_TENTH),
						new Measure(0,UnitInterface.BLANK_TENTH));
		for ( int i = 0; i < 10; i++ ) {
		    TEMPO.addChild(Atom.newAtom("<" + Integer.toString(i) + ">"));
		}
		GlyphInterface theV = new Vertical(new Measure(0,UnitInterface.BLANK_TENTH),
						   new Measure(0,UnitInterface.LINE_TENTH));
		TEMPO.addChild(theV);
		theV.addChild(Atom.newAtom("*1*"));
		theV.addChild(Atom.newAtom("*2*"));
		theV.addChild(Atom.newAtom("*3*"));
		for ( int i = 0; i < 650; i++ ) {
		    TEMPO.addChild(Atom.newAtom("<" + Integer.toString(i) + ">"));
		    TEMPO.addChild(Atom.newAtom('@'));
		}
		theFirst.addChild(TEMPO);
		theFirst.setUnstable();
		theBigV.addChild(theFirst);
		theRoot.addOperation(new InsertGlyph(theBigV,0));
		theFacade.buildInit(theRoot);
		final int MAX = Math.min(50,ITERATIONS);
		for ( int ii = 1; ii < MAX; ii++ ) {
		    java.lang.Thread.yield();
		    PathInterface the0Path = new Path();
		    PathInterface the1Path = new Path(0);
		    the0Path.addChild(the1Path);
		    GlyphInterface theH = new Paragraph(new Measure(0,UnitInterface.BLANK_TENTH),
 							new Measure(75,UnitInterface.BLANK_TENTH),
							new Measure(0,UnitInterface.BLANK_TENTH));
		    theH.setUnstable();
 		    for ( int xx = 0; xx < 3; xx++ ) {
			theH.addChild(Atom.newAtom('.'));
			GlyphInterface theNewContext = new ChangeGraphicalContextAnonymous(null,"rouge","jaune");
			theNewContext.addChild(Atom.newAtom("->"));
			theH.addChild(theNewContext);
			theH.addChild(Atom.newAtom("Foo","foo"));
			theH.addChild(Atom.newAtom("Bar","bar"));
			theH.addChild(Atom.newAtom("Gee","gee"));
			theH.addChild(Atom.newAtom('a'));
			theH.addChild(Atom.newAtom('b'));
			theH.addChild(Atom.newAtom('c'));
			theH.addChild(Atom.newAtom('d'));
			theH.addChild(Atom.newAtom('e'));
			theH.addChild(Atom.newAtom('f'));
			theH.addChild(Atom.newAtom('g'));
			theH.addChild(Atom.newAtom('h'));
			theH.addChild(Atom.newAtom('i'));
			theH.addChild(Atom.newAtom('j'));
			theH.addChild(Atom.newAtom('k'));
			theH.addChild(Atom.newAtom('l'));
			theH.addChild(Atom.newAtom('m'));
			theH.addChild(Atom.newAtom('n'));
			theH.addChild(Atom.newAtom('o'));
			theH.addChild(Atom.newAtom('p'));
			theH.addChild(Atom.newAtom('q'));
			theH.addChild(Atom.newAtom('r'));
			theH.addChild(Atom.newAtom('s'));
			theH.addChild(Atom.newAtom('t'));
			theH.addChild(Atom.newAtom('u'));
			theH.addChild(Atom.newAtom('v'));
			theH.addChild(Atom.newAtom('w'));
			theH.addChild(Atom.newAtom('x'));
			theH.addChild(Atom.newAtom('y'));
			theH.addChild(Atom.newAtom('z'));
		    }
		    the1Path.addOperation(new InsertGlyph(theH,ii));
		    PathInterface the1BPath = new Path(ii - 1);
		    the1BPath.addOperation(MarkStable.INSTANCE);
		    the1Path.addChild(the1BPath);
		    theFacade.build(the0Path);
		}
		PathInterface the00Path = new Path();
		PathInterface the01Path = new Path(0);
		the00Path.addChild(the01Path);
		PathInterface the02Path = new Path(MAX - 1);
		the02Path.addOperation(MarkStable.INSTANCE);
		the01Path.addChild(the02Path);
		theFacade.build(the00Path);
		theFacade.buildComplete();
	    }
	    else {
		if ( XML_TEST_FLAG ) {
		    try {
			FigueLexer theLexer = new FigueLexer(new DataInputStream(new FileInputStream("test")));
			FigueParser theParser = new FigueParser(theLexer);
			theParser.document();
			CommonAST theTree = (CommonAST)theParser.getAST();
			FigueWalker theWalker = new FigueWalker();
			PathInterface thePath = theWalker.path(theTree);
			theFacade.buildInit(thePath);
			theFacade.buildComplete();
		    }
		    catch ( FileNotFoundException anException ) {
			System.exit(0);
		    }
		    catch ( ParserException anException ) {
			System.exit(0);
		    }
		    catch ( IOException anException ) {
			System.exit(0);
		    }
		}
		else {
		    if ( MINI_TEST_FLAG ) {
// 			final URL theUrl;
// 			try {
// 			    theUrl = new URL("file://localhost/"+System.getProperty("user.dir")+"/web/jape/");
// 			}
// 			catch ( MalformedURLException e ) {
// 			    e.printStackTrace();
// 			    theUrl = null;
// 			}
			final PortableFontInterface theFont = theFacade.doGetPortableFont(null,"laurass12",600,1.5);
// 			    = new PortableFont(((InteractiveFacade)theFacade).getAwtComponent(),
// 					       theUrl,
// 					       "laurass12",600,1.5);
			/*******************/
			GlyphInterface theObject0;
			theObject0 = new Vertical(0,0);
			final GlyphInterface theFirstExpr = Atom.newAtom("1");
			theObject0.addChild(theFirstExpr);
			theObject0.addChild(Atom.newAtom("xxx&#169;yyy"));
			theObject0.addChild(Atom.newAtom("test"));
			theObject0.addChild(new Symbol(showFace("3: ",128,192),theFont));
			theObject0.addChild(new Symbol(showFace("4: ",192,256),theFont));
			theObject0.addChild(new Symbol(showFace("1: ",0,64),theFont));
			theObject0.addChild(new Symbol(showFace("2: ",64,128),theFont));
			theObject0.addChild(Atom.newAtom("zzz&#xA9;www"));
			final GlyphInterface theThirdExpr = new Horizontal(0);
			theThirdExpr.addChild(Atom.newAtom("2"));
			theObject0.addChild(theThirdExpr);
			GlyphInterface theObject1 = Atom.newAtom("{houba}");
			GlyphInterface theObject2 = Atom.newAtom("{pas glop}");
			GlyphInterface theObject3 = new Horizontal(new Measure(25,UnitInterface.BLANK_TENTH));
			theObject3.addChild(Atom.newAtom("pim"));
			RoundButton theButton = new RoundButton((float)0.0,(float)0.5);
			theObject3.addChild(new LightweightComponentAdapter(theButton));
			theObject3.addChild(Atom.newAtom("you know what i'm happy","nega"));
			theObject3.addChild(Atom.newAtom("pam"));
			theButton = new RoundButton((float)0.0,(float)1.0);
			theObject3.addChild(new LightweightComponentAdapter(theButton));
			theObject3.addChild(Atom.newAtom("poum"));
			theButton = new RoundButton((float)0.0,(float)0.0);
			theObject3.addChild(new LightweightComponentAdapter(theButton));
			GlyphInterface theObject4 = Atom.newAtom("{hop}");
			theObject0.addChild(theObject1);
			theObject0.addChild(theObject2);
			GlyphInterface theObject6 = new ChangeGraphicalContextAnonymous("gros italique","noir","jaune");
			GlyphInterface theObject5 = new Horizontal(new Measure(5,UnitInterface.BLANK_TENTH));
			theObject5.addChild(new ChangeGraphicalContextNamed("sheetos"));
			theObject5.addChild(new ChangeGraphicalContextNamed("sheetos"));
			theObject5.addChild(new ChangeGraphicalContextNamed("sheetos"));
			theObject5.addChild(new ChangeGraphicalContextNamed("sheetos"));
			theObject5.addChild(Atom.newAtom("{Nouveau}"));
			GlyphInterface theObject50 
			    = new ChangeGraphicalContextAnonymous("tres gros gras","bleu","rose");

 			GlyphInterface theObject500 = new Vertical(new Measure(3,UnitInterface.BLANK_TENTH),
								       new Measure(5,UnitInterface.LINE_TENTH));
			theObject500.addChild(new ChangeGraphicalContextNamed("sheetos"));
			theObject500.addChild(Atom.newAtom("{Un}"));
			theObject500.addChild(Atom.newAtom("{Premier}"));
			theObject500.addChild(new ChangeGraphicalContextNamed("sheetos"));
			theObject500.addChild(new ChangeGraphicalContextNamed("sheetos"));
			theObject500.addChild(Atom.newAtom("{Petit}"));
			theObject500.addChild(Atom.newAtom("{Test}"));
			theObject5.addChild(theObject500);
			theObject50.addChild(Atom.newAtom("{New}"));
			theObject5.addChild(theObject50);
			GlyphInterface theObject501 = new Horizontal(new Measure(20,UnitInterface.BLANK_TENTH));
			Paragraph thePara = new Paragraph(new Measure(0,UnitInterface.BLANK_TENTH),
							  new Measure(75,UnitInterface.BLANK_TENTH),
							  new Measure(0,UnitInterface.BLANK_TENTH));
			thePara.addChild(Atom.newAtom('X'));
			thePara.addChild(new Symbol(showFace("",128,129),theFont));
			thePara.addChild(Atom.newAtom('Y'));
			thePara.addChild(new Symbol(showFace("",129,130),theFont));
			thePara.addChild(new Symbol(showFace("",130,131),theFont));
			thePara.addChild(Atom.newAtom('Z'));
			thePara.addChild(new Symbol("g",theFont));
			theButton = new RoundButton((float)0.0,(float)0.5);
			thePara.addChild(new LightweightComponentAdapter(theButton));
			thePara.addChild(new Symbol(showFace("",131,132),theFont));
			thePara.addChild(Atom.newAtom('W'));
			GlyphInterface theLink
			    = new Hyperlink("dummy link",
					    new HyperlinkHistoryInterface() {
				public final void clear() {
				    _followedLinks.clear();
				}
				public final boolean isVisited(Hyperlink aLink) {
				    return _followedLinks.containsKey((String)(aLink.getInfo()));
				}
				public final void setVisited(Hyperlink aLink) {
				    _followedLinks.put((String)(aLink.getInfo()),this);
				}
				private Hashtable _followedLinks = new Hashtable();
			    });
			theLink.addChild(Atom.newAtom("Click"));
			theLink.addChild(Atom.newAtom("on"));
			theLink.addChild(Atom.newAtom("me"));
			thePara.addChild(theLink);
			thePara.addChild(Atom.newAtom('Z'));
			theObject501.addChild(thePara);
			theObject501.addChild(new ChangeGraphicalContextNamed("sheetos"));
			theObject5.addChild(theObject501);
			theObject5.addChild(Atom.newAtom("{Neuf}"));
			theObject6.addChild(theObject5);
			theObject0.addChild(theObject6); 
			theObject0.addChild(theObject3);
			theObject0.addChild(Atom.newAtom("*********************"));
			GlyphInterface theLineForInset = new Horizontal();
			theLineForInset.addChild(Atom.newAtom('<'));
			GlyphInterface theInsets = new Insets(80,160,30,70);
			theLineForInset.addChild(theInsets);
			theLineForInset.addChild(Atom.newAtom('>'));
			GlyphInterface theFrame = new Horizontal();
			theFrame.addChild(Atom.newAtom("XXX"));
			theFrame.addChild(Atom.newAtom("YYY"));
			GlyphInterface theGreekContext =
			    new ChangeGraphicalContextNamed("grec");
			GlyphInterface theGreekLine = new Horizontal(new Measure(5,UnitInterface.BLANK_TENTH));
			theGreekContext.addChild(theGreekLine);
			theFrame.addChild(theGreekContext);
			theGreekLine.addChild(Atom.newAtom("Pas"));
			theGreekLine.addChild(Atom.newAtom("Glop"));
			theGreekLine.addChild(Atom.newAtom("Pas"));
			theGreekLine.addChild(Atom.newAtom("Glop"));
			theFrame.addChild(Atom.newAtom("ZZZ"));
			theInsets.addChild(theFrame);
			theObject0.addChild(theLineForInset);
			theObject0.addChild(Atom.newAtom("*********************"));
			PathInterface theRoot = new Path();
			if ( false ) {
			    theRoot.addOperation(new InsertGlyph(theObject0,0));
			}
			else {
			    GlyphInterface theDebugGlyph = new DebugRefreshZone(theObject0,"rouge");
			    theRoot.addOperation(new InsertGlyph(theDebugGlyph,0));
			}
			/***************************/
			/////////////////////////////////
			/*****************************
			PathInterface theRoot = null;
			try {
			    System.out.println("->");
			    final FigueLexer theLexer = new FigueLexer(new DataInputStream(new FileInputStream("test")));
			    System.out.println("-> parsing");
			    final FigueParser theParser = new FigueParser(theLexer);
			    theParser.document();
			    final CommonAST theTree = (CommonAST)theParser.getAST();
			    System.out.println("-> walking");
			    final FigueWalker theWalker = new FigueWalker();
			    theRoot = theWalker.path(theTree);
			    System.out.println("-> building");
			}
			catch ( ParserException e ) {
			    e.printStackTrace();
			}
			catch ( IOException e ) {
			    e.printStackTrace();
			}
			************************************/
			////////////////////////////////
			theFacade.buildInit(theRoot);
			theFacade.buildComplete();
		    }
		    else {
			GlyphInterface theObject0;
			theObject0 = new Vertical(new Measure(15,UnitInterface.BLANK_TENTH),
						  new Measure(0,UnitInterface.LINE_TENTH));
			GlyphInterface theObject1 = Atom.newAtom("{houba}");
			GlyphInterface theObject2 = Atom.newAtom("{pas glop}");
			GlyphInterface theObject3 = Atom.newAtom("{pim pam poum}");
			GlyphInterface theObject4 = Atom.newAtom("{hop}");
			theObject0.addChild(theObject1);
			theObject0.addChild(theObject2);
			GlyphInterface theObject6 =
			    new ChangeGraphicalContextAnonymous("gros italique","noir","jaune");
			GlyphInterface theObject5 = new Horizontal(new Measure(5,UnitInterface.BLANK_TENTH));
			theObject5.addChild(Atom.newAtom("{Nouveau}"));
			GlyphInterface theObject50 
			    = new ChangeGraphicalContextAnonymous("tres gros gras","bleu","rose");
			GlyphInterface theObject500 = new Vertical(new Measure(3,UnitInterface.BLANK_TENTH),
								   new Measure(5,UnitInterface.LINE_TENTH));
			theObject500.addChild(Atom.newAtom("{Un}"));
			theObject500.addChild(Atom.newAtom("{Premier}"));
			theObject500.addChild(Atom.newAtom("{Petit}"));
			theObject500.addChild(Atom.newAtom("{Test}"));
			theObject5.addChild(theObject500);
			theObject50.addChild(Atom.newAtom("{New}"));
			theObject5.addChild(theObject50);
			theObject5.addChild(Atom.newAtom("{Neuf}"));
			theObject6.addChild(theObject5);
			theObject0.addChild(theObject6); 
			theObject0.addChild(theObject3);
			theObject0.addChild(theObject4);
			GlyphInterface theBigBackground 
			    = new ChangeGraphicalContextAnonymous(null,"bleu","blanc");
			theObject0.addChild(theBigBackground);
			GlyphInterface theBigV = new Vertical(new Measure(30,UnitInterface.BLANK_TENTH),
							      new Measure(0,UnitInterface.LINE_TENTH));
			theBigBackground.addChild(theBigV);
			GlyphInterface theHObjects = null;
			GlyphInterface theVObjects = null;
			for ( int ii = 0; ii < 30; ii++ ) { 
			    final String I = String.valueOf(ii);
			    theHObjects = new Paragraph(new Measure(0,UnitInterface.BLANK_TENTH),
							new Measure(75,UnitInterface.BLANK_TENTH),
							new Measure(0,UnitInterface.BLANK_TENTH));
			    if ( ii == 29 ) {
				theHObjects.setUnstable();
			    }
			    GlyphInterface forTheFirstShared
				= new ChangeGraphicalContextNamed("sheetos");
			    forTheFirstShared.addChild(Atom.newAtom("{Nouveau}"));
			    theHObjects.addChild(forTheFirstShared);
			    for ( int jj = 0; jj < 15; jj++ ) {
				if ( ( jj == 1 ) || ( jj == 5 ) ) {
				    GlyphInterface forTheOtherShared
					= new ChangeGraphicalContextAnonymous("petit italique","rouge",null);
				    forTheOtherShared.addChild(Atom.newAtom("{Nouveau}"));
				    theHObjects.addChild(forTheOtherShared);
				}
				else {
				    GlyphInterface forTheOtherShared
					= new ChangeGraphicalContextAnonymous("moyen","noir",null);
				    forTheOtherShared.addChild(Atom.newAtom("{Nouveau}"));
				    theHObjects.addChild(forTheOtherShared);
				}
				theHObjects.addChild(Atom.newAtom("un"));
				theHObjects.addChild(Atom.newAtom("test"));
			    }
			    theBigV.addChild(theHObjects);
			}
			PathInterface theRoot = new Path();
			theRoot.addOperation(new InsertGlyph(theObject0,0));
			theFacade.buildInit(theRoot);
			
			SelectionInterface theSelection1 = 
			    theFacade.doGetSelection("SELECTION 1",
						     Priority.MEDIUM,
						     "gris leger",
						     null);
			SelectionInterface theSelection2 = 
			    theFacade.doGetSelection("SELECTION 2",
						     Priority.HIGH,
						     null,
						     "cyan");
			GlyphInterface theLetters = null;
			GlyphInterface theOtherLetters = null;
			GlyphInterface theOtherOtherLetters = null;
			final int MAX = 500;
			for ( int ii = 30; ii < MAX; ii++ ) {
			    java.lang.Thread.yield();
			    theHObjects = new Paragraph(new Measure(0,UnitInterface.BLANK_TENTH),
							new Measure(75,UnitInterface.BLANK_TENTH),
							new Measure(0,UnitInterface.BLANK_TENTH));
			    theHObjects.setUnstable();
			    GlyphInterface forTheFirstShared
				= new ChangeGraphicalContextNamed("sheetos");
			    forTheFirstShared.addChild(Atom.newAtom("{Nouveau}"));
			    theHObjects.addChild(forTheFirstShared);
			    for ( int jj = 0; jj < 15; jj++ ) {
				if ( jj == 2 ) {
				    theVObjects = new Vertical(new Measure(50,UnitInterface.BLANK_TENTH),
							       new Measure(0,UnitInterface.LINE_TENTH));
				    for ( int kk = 0; kk < 3; kk++ ) {
					theVObjects.addChild(Atom.newAtom("Des atomes"));
				    }
				    theHObjects.addChild(theVObjects);
				}
				else {
				    if ( ( jj == 1 ) || ( jj == 4 ) ) {
					GlyphInterface forTheOtherShared
					    = new ChangeGraphicalContextAnonymous("petit italique","rouge",null);
					forTheOtherShared.addChild(Atom.newAtom("{Nouveau}"));
					theHObjects.addChild(forTheOtherShared);
				    }
				    else {
					GlyphInterface forTheOtherShared
					    = new ChangeGraphicalContextAnonymous("moyen","noir",null);
					forTheOtherShared.addChild(Atom.newAtom("{Nouveau}"));
					theHObjects.addChild(forTheOtherShared);
				    }
				    theHObjects.addChild(Atom.newAtom("un"));
				    theHObjects.addChild(Atom.newAtom("test"));
				}
			    }
			    PathInterface the0Path = new Path();
			    PathInterface the1Path = new Path(0);
			    the0Path.addChild(the1Path);
			    PathInterface the2Path = new Path(5);
			    the1Path.addChild(the2Path);
			    PathInterface the3Path = new Path(0);
			    the3Path.addOperation(new InsertGlyph(theHObjects,ii));
			    the2Path.addChild(the3Path);
			    PathInterface the4Path = new Path(ii - 1);
			    the4Path.addOperation(MarkStable.INSTANCE);
			    the3Path.addChild(the4Path);
			    theFacade.build(the0Path);
			}
			PathInterface the00Path = new Path();
			PathInterface the01Path = new Path(0);
			the00Path.addChild(the01Path);
			PathInterface the02Path = new Path(5);
			the01Path.addChild(the02Path);
			PathInterface the03Path = new Path(0);
			the02Path.addChild(the03Path);
			PathInterface the04Path = new Path(MAX - 1);
			the04Path.addOperation(MarkStable.INSTANCE);
			the03Path.addChild(the04Path);
			theFacade.build(the00Path);
			theFacade.buildComplete();
		    }
		}
	    }

	    endOfTest();
	}
	catch ( WrongResourceException anException ) {
	    anException.printStackTrace();
	    System.exit(-1);
	}
	catch ( WrongSelectionException anException ) {
	    anException.printStackTrace();
	    System.exit(-1);
	}
	Thread.yield();
    }

    private final String showFace(String s, int m, int n) { 
	StringBuffer r = new StringBuffer(s);
	for (int i = m; i<n; i++)
	    r.append((char)i);
	return r.toString();
    }
    
    static int TYPE_TEST = 0;
    static boolean ALPHABET_TEST_FLAG = false;
    static boolean MINI_TEST_FLAG = false;
    static boolean XML_TEST_FLAG = false;
    static int ITERATIONS = 1000000;

    final static int ASCII = 1;
    final static int AWT = 2;
    final static int PS = 3;
    final static int SWING = 4;
  
}

final class TestKeyListener extends DefaultKeyListener {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/various/Test.java,v $ $revision$ $Date: 1998/11/02 15:56:04 $ Copyright 1998 INRIA.";

    protected TestKeyListener(InteractiveFacade aFacade) {
	super(aFacade);
    }
  
    public final void keyTyped(KeyEvent anEvent) {
	switch ( anEvent.getKeyCode() ) {
	case KeyEvent.VK_A:
	case KeyEvent.VK_B:
	case KeyEvent.VK_C:
	case KeyEvent.VK_D:
	case KeyEvent.VK_E:
	case KeyEvent.VK_F:
	case KeyEvent.VK_G:
	case KeyEvent.VK_H:
	case KeyEvent.VK_I:
	case KeyEvent.VK_J:
	case KeyEvent.VK_K:
	case KeyEvent.VK_L:
	case KeyEvent.VK_M:
	case KeyEvent.VK_N:
	case KeyEvent.VK_O:
	case KeyEvent.VK_P:
	case KeyEvent.VK_Q:
	case KeyEvent.VK_R:
	case KeyEvent.VK_S:
	case KeyEvent.VK_T:
	case KeyEvent.VK_U:
	case KeyEvent.VK_V:
	case KeyEvent.VK_W:
	case KeyEvent.VK_X:
	case KeyEvent.VK_Y:
	case KeyEvent.VK_Z:
	case KeyEvent.VK_0:
	case KeyEvent.VK_1:
	case KeyEvent.VK_2:
	case KeyEvent.VK_3:
	case KeyEvent.VK_4:
	case KeyEvent.VK_5:
	case KeyEvent.VK_6:
	case KeyEvent.VK_7:
	case KeyEvent.VK_8:
	case KeyEvent.VK_9:
	case KeyEvent.VK_NUMPAD0:
	case KeyEvent.VK_NUMPAD1:
	case KeyEvent.VK_NUMPAD2:
	case KeyEvent.VK_NUMPAD3:
	case KeyEvent.VK_NUMPAD4:
	case KeyEvent.VK_NUMPAD5:
	case KeyEvent.VK_NUMPAD6:
	case KeyEvent.VK_NUMPAD7:
	case KeyEvent.VK_NUMPAD8:
	case KeyEvent.VK_NUMPAD9:
	case KeyEvent.VK_ADD:
	case KeyEvent.VK_BACK_QUOTE:
	case KeyEvent.VK_BACK_SLASH:
	case KeyEvent.VK_CLOSE_BRACKET:
	case KeyEvent.VK_COMMA:
	case KeyEvent.VK_DECIMAL:
	case KeyEvent.VK_DIVIDE:
	case KeyEvent.VK_EQUALS:
	case KeyEvent.VK_MULTIPLY:
	case KeyEvent.VK_OPEN_BRACKET:
	case KeyEvent.VK_PERIOD:
	case KeyEvent.VK_QUOTE:
	case KeyEvent.VK_SEMICOLON:
	case KeyEvent.VK_SLASH:
	case KeyEvent.VK_SPACE:
	case KeyEvent.VK_SUBTRACT:
	case KeyEvent.VK_UNDEFINED: {
	    PathInterface theInsertPath = computeInsertPath(getFacade().getSelectionPath(),
							    getCurrentSelection(),
							    anEvent.getKeyChar());
	    if ( theInsertPath != null ) {
		applyToGlyphAndRedisplay(theInsertPath);
	    }
	    break;
	}
	default: {
	    super.keyTyped(anEvent);
	    break;
	}
	}
    }

    public final void keyPressed(KeyEvent anEvent) {
	switch ( anEvent.getKeyCode() ) {
	case KeyEvent.VK_DELETE:
	case KeyEvent.VK_BACK_SPACE:
	case KeyEvent.VK_CLEAR: {
	    PathInterface theRemovePath = computeDeletePath(getFacade().getSelectionPath(),
							    getCurrentSelection());
	    if ( theRemovePath != null ) {
		applyToGlyphAndRedisplay(theRemovePath);
	    }
	    break;
	}
	default: {
	    super.keyPressed(anEvent);
	    break;
	}
	}
    }

    private final PathInterface computeInsertPath(SelectionPathInterface aSelectionPath,
						  SelectionInterface aSelection,
						  char aChar) {
	PathInterface theResult = null;
	final int theSize = aSelectionPath.numberOfChildren();
	SelectionPathInterface theChild;
	PathInterface theResultForChild;
	for( int theRank = 0; theRank < theSize; theRank++ ) {
	    theChild = aSelectionPath.getChild(theRank);
	    if ( theChild.contains(aSelection) ) {
		if ( theResult == null ) {
		    theResult = new Path(0);
		}
		theResult.addOperation(new InsertGlyph(Atom.newAtom(aChar),
						       theChild.getRank()));
		return theResult;
	    }
	    theResultForChild = computeInsertPath(theChild,aSelection,aChar);
	    if ( theResultForChild != null ) {
		if ( theResult == null ) {
		    theResult = new Path(0);
		}
		theResultForChild.setRank(theChild.getRank());
		theResult.addChild(theResultForChild);
	    }
	}
	return theResult;   
    }

    private final PathInterface computeDeletePath(SelectionPathInterface aSelectionPath,
						  SelectionInterface aSelection) {
	PathInterface theResult = null;
	final int theSize = aSelectionPath.numberOfChildren();
	SelectionPathInterface theChild;
	PathInterface theResultForChild;
	int theAlreadyDeleteNumber = 0;
	for( int theRank = 0; theRank < theSize; theRank++ ) {
	    theChild = aSelectionPath.getChild(theRank);
	    if ( theChild.contains(aSelection) ) {
		if ( theResult == null ) {
		    theResult = new Path(0);
		}
		theResult.addOperation(new RemoveGlyph(theChild.getRank() - theAlreadyDeleteNumber++));
	    }
	    else {
		theResultForChild = computeDeletePath(theChild,aSelection);
		if ( theResultForChild != null ) {
		    if ( theResult == null ) {
			theResult = new Path(0);
		    }
		    theResultForChild.setRank(theChild.getRank() - theAlreadyDeleteNumber);
		    theResult.addChild(theResultForChild);
		}
	    }
	}
	return theResult;   
    }
  
}

final class InteractiveTestThread extends TestThread {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/various/Test.java,v $ $revision$ $Date: 1998/11/02 15:56:04 $ Copyright 1998 INRIA.";
  
    public InteractiveTestThread(InteractiveFacade aFacade, Frame aFrame) {
	super();
	_facade = aFacade;
	_frame = aFrame;
    }

    public final FacadeInterface getFacade() {
	return _facade;
    }

    public void endOfTest() {
// 	try {
// 	    Thread.sleep(5000);
// 	    PrintWriter theOutput = new PrintWriter(System.out);
// 	    _facade.writeState(theOutput);
// 	    theOutput.flush();
// 	}
// 	catch ( IOException e ) {
// 	    System.exit(0);
// 	}
// 	catch ( InterruptedException e ) {
// 	    ;
// 	}
// 	try {
// 	    AWTFacade theNewFacade = new AWTFacade(new FacadeInitializer(),
// 						   _facade);
// 	    Frame theTest0 = new Frame();
// 	    theTest0.setLayout(new BorderLayout());
// 	    theTest0.setSize(590,831);
// 	    theTest0.add(BorderLayout.CENTER,theNewFacade.getAwtComponent());
// 	    theTest0.setVisible(true);
// 	    theNewFacade.buildInit(null);
// 	    theNewFacade.buildComplete();
// 	}
// 	catch ( WrongResourceException e ) {
// 	    e.printStackTrace();
// 	}
// 	catch ( CloneNotSupportedException e ) {
// 	    e.printStackTrace();
// 	}
    }

    public final void dispose() {
	_frame.dispose();
	_frame = null;
	_facade.disposeWhenInactive();
	_facade = null;
	super.dispose();
    }
  
    private InteractiveFacade _facade;
    private Frame _frame;
  
}

final class ASCIITestThread extends TestThread {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/various/Test.java,v $ $revision$ $Date: 1998/11/02 15:56:04 $ Copyright 1998 INRIA.";

    public ASCIITestThread(ASCIIFacade aFacade) {
	super();
	_facade = aFacade;
    }

    public final FacadeInterface getFacade() {
	return _facade;
    }

    public void endOfTest() {
	_facade.update(new OutputStreamWriter(System.out));
	_facade.disposeWhenInactive();
	_facade = null;
	super.dispose();
    }

    public final void dispose() {
	_facade.disposeWhenInactive();
	_facade = null;
	super.dispose();
    }
  
    private ASCIIFacade _facade;
  
}

final class PSTestThread extends TestThread {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/various/Test.java,v $ $revision$ $Date: 1998/11/02 15:56:04 $ Copyright 1998 INRIA.";

    public PSTestThread(PSFacade aFacade, Frame aFrame) {
	super();
	_facade = aFacade;
	_frame = aFrame;
    }

    public final FacadeInterface getFacade() {
	return _facade;
    }

    public void endOfTest() {
	_facade.print();
	_facade.disposeWhenInactive();
	_facade = null;
	_frame.dispose();
	_frame = null;
    }

    public final void dispose() {
	_facade.disposeWhenInactive();
	_facade = null;
	_frame = null;
	super.dispose();
    }
  
    private PSFacade _facade;
    private Frame _frame;
  
}

class RoundButton extends Component implements LightweightInterface {
  
    public RoundButton(float alignmentX, float alignmentY) {
	_alignmentX = alignmentX;
	_alignmentY = alignmentY;
	_pressedFlag = false;
	_parent = null;
	_label = " grow ";
	_counter = 0;
	_increment = 1;
	setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
	enableEvents(AWTEvent.MOUSE_EVENT_MASK);
    }

    public Object clone() throws CloneNotSupportedException {
	final RoundButton theResult = (RoundButton) super.clone();
	theResult._alignmentX = _alignmentX;
	theResult._alignmentY = _alignmentY;
	theResult._pressedFlag = false;
	theResult._label = " grow ";
	theResult._counter = 0;
	theResult._increment = 1;
	theResult.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
	theResult.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	return theResult;
    }
  
    public void repaint() {
	if ( _parent != null ) {
	    _parent.refresh();
	}
    }
  
    public void invalidate() {
	if ( _parent != null ) {
	    _parent.invalidate();
	}
    }
  
    public void setParent(LightweightComponentAdapter aGlyph) {
	_parent = aGlyph;
    }
  
    public float getAlignmentX() {
	return _alignmentX;
    }
  
    public float getAlignmentY() {
	return _alignmentY;
    }
  
    public void paint(Graphics g) {
	update(g);
    }
  
    public void update(Graphics g) {
	int s = Math.min(getSize().width - 1, getSize().height - 1);
	if(_pressedFlag) {
	    g.setColor(java.awt.Color.red);
      
	} else {
	    g.setColor(getForeground());
	}
	g.fillArc(0, 0, s, s, 0, 360);
	g.drawArc(0, 0, s, s, 0, 360);
	java.awt.Font f = getFont();
	if(f != null) {
	    java.awt.FontMetrics fm = getFontMetrics(getFont());
	    g.setColor(getBackground());
	    g.drawString(_label,
			 s/2 - fm.stringWidth(_label)/2,
			 s/2 + fm.getMaxDescent());
	}
    }
  
    public java.awt.Dimension getPreferredSize() {
	java.awt.Font f = getFont();
	if(f != null) {
	    java.awt.FontMetrics fm = getFontMetrics(getFont());
	    final int x = 40 + (_counter * 5);
	    int max = Math.max(fm.stringWidth(_label) + x, fm.getHeight() + x);
	    return new java.awt.Dimension(max, max);
	} else {
	    return new java.awt.Dimension(100, 100);
	}
    }
  
    public java.awt.Dimension getMinimumSize() {
	return new java.awt.Dimension(100, 100);
    }
  
    public void processMouseEvent(MouseEvent e) {
	Graphics g;
	switch(e.getID()) {
	case MouseEvent.MOUSE_PRESSED:
	    _pressedFlag = true;
	    repaint(); 
	    break;
	case MouseEvent.MOUSE_RELEASED:
	    if(_pressedFlag == true) {
		_pressedFlag = false;
		repaint();
	    }
	    break;
	case MouseEvent.MOUSE_CLICKED:
	    _counter+=_increment;
	    if ( _counter < 1 ) {
		_increment = +1;
		_label = " grow ";
	    }
	    else {
		if ( _counter > 5 ) {
		    _increment = -1;
		    _label = "shrink";
		}
	    }
	    invalidate();
	    break;
	case MouseEvent.MOUSE_ENTERED:
	    break;
	case MouseEvent.MOUSE_EXITED:
	    if(_pressedFlag == true) {
		_pressedFlag = false;
		repaint();
	    }
	    break;
	}
	super.processMouseEvent(e);
    }
    
    private float _alignmentX;
    private float _alignmentY;
    private String _label;
    protected boolean _pressedFlag;
    private int _counter;
    private int _increment;
    private LightweightComponentAdapter _parent;
    
}


